package com.zt.plat.module.qms.business.bus.dal.mapper;

import java.util.*;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.zt.plat.framework.mybatis.core.query.MPJLambdaWrapperX;
import com.zt.plat.module.qms.business.bus.controller.vo.*;
import com.zt.plat.module.qms.business.bus.dal.dataobject.BusinessQCManagementParameterDataDO;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigAssayMethodProjectParameterDO;
import com.zt.plat.module.qms.common.dic.dal.dataobject.DictionaryBusinessDO;
import com.zt.plat.framework.mybatis.core.mapper.BaseMapperX;
import org.apache.ibatis.annotations.Mapper;

/**
 * 质控样检测参数数据业务 Mapper
 *
 * @author 后台管理
 */
@Mapper
public interface BusinessQCManagementParameterDataMapper extends BaseMapperX<BusinessQCManagementParameterDataDO> {

    default PageResult<BusinessQCManagementParameterDataDO> selectPage(BusinessQCManagementParameterDataPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<BusinessQCManagementParameterDataDO>()
                .eqIfPresent(BusinessQCManagementParameterDataDO::getBusinessQCManagementProjectDataId, reqVO.getBusinessQCManagementProjectDataId())
                .eqIfPresent(BusinessQCManagementParameterDataDO::getConfigAssayMethodProjectParameterId, reqVO.getConfigAssayMethodProjectParameterId())
                .eqIfPresent(BusinessQCManagementParameterDataDO::getDictionaryParameterId, reqVO.getDictionaryParameterId())
                .eqIfPresent(BusinessQCManagementParameterDataDO::getValue, reqVO.getValue())
                .eqIfPresent(BusinessQCManagementParameterDataDO::getDataType, reqVO.getDataType())
                .eqIfPresent(BusinessQCManagementParameterDataDO::getDecimalPosition, reqVO.getDecimalPosition())
                .eqIfPresent(BusinessQCManagementParameterDataDO::getSystemDepartmentCode, reqVO.getSystemDepartmentCode())
                .betweenIfPresent(BusinessQCManagementParameterDataDO::getCreateTime, reqVO.getCreateTime())
                .eqIfPresent(BusinessQCManagementParameterDataDO::getUpdateCount, reqVO.getUpdateCount())
                .eqIfPresent(BusinessQCManagementParameterDataDO::getRemark, reqVO.getRemark())
                .orderByDesc(BusinessQCManagementParameterDataDO::getId));
    }
    
    default List<BusinessAssayProjectAndParameterRespVO> selectProjectAndParameterBy(BusinessQCManagementParameterDataReqVO reqVO) {
    	return selectJoinList(BusinessAssayProjectAndParameterRespVO.class, new MPJLambdaWrapperX<BusinessQCManagementParameterDataDO>()
				.leftJoin(ConfigAssayMethodProjectParameterDO.class, ConfigAssayMethodProjectParameterDO::getId, BusinessQCManagementParameterDataDO::getConfigAssayMethodProjectParameterId)
				.leftJoin(DictionaryBusinessDO.class, DictionaryBusinessDO::getId, ConfigAssayMethodProjectParameterDO::getDictionaryBusinessId)
				.selectAs(BusinessQCManagementParameterDataDO::getId, BusinessAssayProjectAndParameterRespVO::getId)
				.selectAs(BusinessQCManagementParameterDataDO::getBusinessQCManagementProjectDataId, BusinessAssayProjectAndParameterRespVO::getBizId)
				.selectAs(BusinessQCManagementParameterDataDO::getConfigAssayMethodProjectParameterId, BusinessAssayProjectAndParameterRespVO::getDicId)
				.selectAs(ConfigAssayMethodProjectParameterDO::getKey, BusinessAssayProjectAndParameterRespVO::getDicKey)
				.selectAs(ConfigAssayMethodProjectParameterDO::getParameterName, BusinessAssayProjectAndParameterRespVO::getName)
				.selectAs(ConfigAssayMethodProjectParameterDO::getParameterName, BusinessAssayProjectAndParameterRespVO::getShowName)
				.selectAs(ConfigAssayMethodProjectParameterDO::getFillingWay, BusinessAssayProjectAndParameterRespVO::getFillingWay)
				.selectAs(BusinessQCManagementParameterDataDO::getDataType, BusinessAssayProjectAndParameterRespVO::getDataType)
				.selectAs(BusinessQCManagementParameterDataDO::getDecimalPosition, BusinessAssayProjectAndParameterRespVO::getDecimalPosition)
				.selectAs(BusinessQCManagementParameterDataDO::getDecimalPosition, BusinessAssayProjectAndParameterRespVO::getEffectiveDigit)//有效数字位与小数位相同
				.selectAs(BusinessQCManagementParameterDataDO::getValue, BusinessAssayProjectAndParameterRespVO::getValue)
				.selectAs(BusinessQCManagementParameterDataDO::getSymbol, BusinessAssayProjectAndParameterRespVO::getSymbol)
				.selectAs(ConfigAssayMethodProjectParameterDO::getUnit, BusinessAssayProjectAndParameterRespVO::getUnit)
				.selectAs(ConfigAssayMethodProjectParameterDO::getIsNull, BusinessAssayProjectAndParameterRespVO::getIsNull)
				.selectAs(ConfigAssayMethodProjectParameterDO::getFormula, BusinessAssayProjectAndParameterRespVO::getFormula)
				.selectAs(ConfigAssayMethodProjectParameterDO::getNo, BusinessAssayProjectAndParameterRespVO::getParamNo)
				.selectAs("'parameter'", BusinessAssayProjectAndParameterRespVO::getType)
				.selectAs(ConfigAssayMethodProjectParameterDO::getDictionaryBusinessId, BusinessAssayProjectAndParameterRespVO::getGroupDictionaryBusinessId)
				.selectAs(ConfigAssayMethodProjectParameterDO::getDictionaryBusinessKey, BusinessAssayProjectAndParameterRespVO::getGroupDictionaryBusinessKey)
				.selectAs(DictionaryBusinessDO::getName, BusinessAssayProjectAndParameterRespVO::getGroupDictionaryBusinessName)
                .eqIfPresent(BusinessQCManagementParameterDataDO::getBusinessQCManagementProjectDataId, reqVO.getBusinessQCManagementProjectDataId())
                .eqIfPresent(BusinessQCManagementParameterDataDO::getConfigAssayMethodProjectParameterId, reqVO.getConfigAssayMethodProjectParameterId())
                .eqIfPresent(BusinessQCManagementParameterDataDO::getDictionaryParameterId, reqVO.getDictionaryParameterId())
                .eqIfPresent(BusinessQCManagementParameterDataDO::getValue, reqVO.getValue())
                .eqIfPresent(BusinessQCManagementParameterDataDO::getDataType, reqVO.getDataType())
                .eqIfPresent(BusinessQCManagementParameterDataDO::getDecimalPosition, reqVO.getDecimalPosition())
                .eqIfPresent(BusinessQCManagementParameterDataDO::getSystemDepartmentCode, reqVO.getSystemDepartmentCode())
                .betweenIfPresent(BusinessQCManagementParameterDataDO::getCreateTime, reqVO.getCreateTime())
                .eqIfPresent(BusinessQCManagementParameterDataDO::getUpdateCount, reqVO.getUpdateCount())
                .eqIfPresent(BusinessQCManagementParameterDataDO::getRemark, reqVO.getRemark())
                .orderByAsc(ConfigAssayMethodProjectParameterDO::getSortNo));
    }
    
    default List<BusinessQCManagementParameterDataDO> selectByBusinessQCManagementProjectDataId(Long businessQCManagementProjectDataId) {
    	return selectList(new LambdaQueryWrapperX<BusinessQCManagementParameterDataDO>()
    			.eq(BusinessQCManagementParameterDataDO::getBusinessQCManagementProjectDataId, businessQCManagementProjectDataId));
    }
    
    default List<BusinessQCManagementParameterDataDO> selectByBusinessQCManagementProjectDataIds(List<Long> businessQCManagementProjectDataIds) {
    	return selectList(new LambdaQueryWrapperX<BusinessQCManagementParameterDataDO>()
    			.in(BusinessQCManagementParameterDataDO::getBusinessQCManagementProjectDataId, businessQCManagementProjectDataIds));
    }

}